package cz.jzitnik.game;

import cz.jzitnik.game.sprites.*;
import cz.jzitnik.game.sprites.SimpleSprite;
import cz.jzitnik.tui.Sprite;
import cz.jzitnik.tui.SpriteList;

import java.util.HashMap;

public class SpriteLoader {
    public enum SPRITES {
        AIR,
        DIRT,
        GRASS,
        STEVE,
        STONE,
        BEDROCK,
        BREAKING,
        COBBLESTONE,
        FURNACE,

        CHEST,
        CRAFTING_TABLE,

        OAK_LOG,
        OAK_LEAF,
        OAK_PLANKS,

        WOODEN_PICKAXE,
        STONE_PICKAXE,
        WOODEN_AXE,
        STONE_AXE,
        WOODEN_SHOVEL,
        STONE_SHOVEL,

        // Items
        ITEM_DIRT,
        ITEM_OAK_LOG,
        ITEM_OAK_PLANKS,
        ITEM_STICK,
        ITEM_COBBLESTONE,
        ITEM_STONE,
        ITEM_FURNACE,

        ITEM_CRAFTING_TABLE,
        ITEM_CHEST
    }

    public static final HashMap<SPRITES, Sprite> SPRITES_MAP = new HashMap<>();

    static {
        SPRITES_MAP.put(SPRITES.AIR, new Air());
        SPRITES_MAP.put(SPRITES.DIRT, new SimpleSprite("dirt.ans"));
        SPRITES_MAP.put(SPRITES.GRASS, new SimpleSprite("grass.ans"));
        SPRITES_MAP.put(SPRITES.STONE, new SimpleSprite("stone.ans"));
        SPRITES_MAP.put(SPRITES.STEVE, new Steve());
        SPRITES_MAP.put(SPRITES.BEDROCK, new SimpleSprite("bedrock.ans"));
        SPRITES_MAP.put(SPRITES.BREAKING, new Breaking());
        SPRITES_MAP.put(SPRITES.OAK_LOG, new SimpleSprite("oak_log.ans"));
        SPRITES_MAP.put(SPRITES.OAK_LEAF, new SimpleSprite("oak_leaf.ans"));
        SPRITES_MAP.put(SPRITES.OAK_PLANKS, new SimpleSprite("oak_planks.ans"));
        SPRITES_MAP.put(SPRITES.CRAFTING_TABLE, new SimpleSprite("crafting_table.ans"));
        SPRITES_MAP.put(SPRITES.CHEST, new SimpleSprite("chest.ans"));
        SPRITES_MAP.put(SPRITES.COBBLESTONE, new SimpleSprite("cobblestone.ans"));
        SPRITES_MAP.put(SPRITES.FURNACE, new Furnace());

        SPRITES_MAP.put(SPRITES.WOODEN_PICKAXE, new SimpleSprite("items/wooden_pickaxe.ans"));
        SPRITES_MAP.put(SPRITES.STONE_PICKAXE, new SimpleSprite("items/stone_pickaxe.ans"));
        SPRITES_MAP.put(SPRITES.WOODEN_AXE, new SimpleSprite("items/wooden_axe.ans"));
        SPRITES_MAP.put(SPRITES.STONE_AXE, new SimpleSprite("items/stone_axe.ans"));
        SPRITES_MAP.put(SPRITES.WOODEN_SHOVEL, new SimpleSprite("items/wooden_shovel.ans"));
        SPRITES_MAP.put(SPRITES.STONE_SHOVEL, new SimpleSprite("items/stone_shovel.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_DIRT, new SimpleSprite("items/dirt.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_LOG, new SimpleSprite("items/oak_log.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_PLANKS, new SimpleSprite("items/oak_planks.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_STICK, new SimpleSprite("items/stick.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_CRAFTING_TABLE, new SimpleSprite("items/crafting_table.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_COBBLESTONE, new SimpleSprite("items/cobblestone.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_STONE, new SimpleSprite("items/stone.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_CHEST, new SimpleSprite("items/chest.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_FURNACE, new SimpleSprite("items/furnace.ans"));
    }

    public static SpriteList<SPRITES> load() {
        return new SpriteList<>(SPRITES.class, SPRITES_MAP);
    }
}
